{% extends 'dashboard/dashboard_content.html' %}

{% block head_block %}
    <script type="text/javascript">
        function reallow_function(year, month, day, hour) {
            {#            alert("hi heloo");#}
            console.log(year);
            console.log(month);
            console.log(day);
            $.ajax({
                type: "POST",
                data: {
                    semester_pk: {{ selected_semester_pk }},
                    course_pk: '{{ selected_course }}',
                    date: year + '-' + month + '-' + day,
                    hour: hour,
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'instant_reallow_attendance' %}',
                success: function (data) {
                    if (data['modal']) {
                        alert(data['modal']['body']);
                    }
                }
            });
        }

        function delete_function(year, month, day, hour) {
            {#            alert("hi heloo");#}
            console.log(year);
            console.log(month);
            console.log(day);
            $.ajax({
                type: "POST",
                data: {
                    semester_pk: {{ selected_semester_pk }},
                    course_pk: '{{ selected_course }}',
                    date: year + '-' + month + '-' + day,
                    hour: hour,
                    csrfmiddlewaretoken: getCookie('csrftoken')
                },
                url: '{% url 'instant_delete_attendance' %}',
                success: function (data) {
                    if (data['modal']) {
                        {#                        alert(data['modal']['body']);#}


                        var $hiddenInput = $('<input/>', {
                            type: 'hidden',
                            value: getCookie('csrftoken'),
                            name: 'csrfmiddlewaretoken'
                        });
                        $hiddenInput.appendTo('form');

                        var $hiddenInput = $('<input/>', {
                            type: 'hidden',
                            value: {{ selected_semester_pk }},
                            name: 'semester_pk'
                        });
                        //alert(this.id);
                        $hiddenInput.appendTo('form');

                        var $hiddenInput = $('<input/>', {
                            type: 'hidden',
                            value: '{{ selected_allotment_pk }}',
                            name: 'selected_allotment_pk'
                        });
                        $hiddenInput.appendTo('form');
                        var $hiddenInput = $('<input/>', {type: 'hidden', value: this.value, name: 'date_range'});
                        $hiddenInput.appendTo('form');
                        $('#week_form').submit();
                    }
                }
            });
        }

    </script>

{% endblock %}

{% block rightPane %}

    <div class="x_panel">
        <div class="x_title">
            <h2>
                <i class="fa fa-file-text-o"></i>
                Weekly Overall Attendance Report
            </h2>
            <div class="clearfix"></div>
        </div>
        <div class="x_content">
            <div class="row">
                {% load auth_extras %}
                {% if request.user|has_group:"principal" or request.user|has_group:"coe_staff" %}
                    <ul class="nav nav-tabs bar_tabs" id="myTab">
                        {% for dept in all_departments %}
                            {% if dept.pk == selected_department_pk %}
                                <li class="active">
                                    <a aria-expanded="true"
                                       id={{ dept.pk }}
                                               data-toggle="tab" name="department_tab">
                                        {{ dept.acronym }}
                                    </a>
                                </li>
                            {% else %}
                                <li class="">
                                    <a aria-expanded="false"
                                       id={{ dept.pk }}
                                               data-toggle="tab" name="department_tab">
                                        {{ dept.acronym }}
                                    </a>
                                </li>
                            {% endif %}
                        {% endfor %}
                    </ul>
                {% endif %}
                <ul class="nav nav-tabs bar_tabs" id="myTab">
                    {% for sem in semesters %}
                        {% if sem.semester_instance.pk == selected_semester_pk %}
                            <li class="active">
                                <a aria-expanded="true"
                                   id={{ sem.semester_instance.pk }}
                                           data-toggle="tab" name="batch_tab">
                                    {{ sem.display_text }}
                                </a>
                            </li>
                        {% else %}
                            <li class="">
                                <a aria-expanded="false"
                                   id={{ sem.semester_instance.pk }}
                                           data-toggle="tab" name="batch_tab">
                                    {{ sem.display_text }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>
                <ul class="nav nav-tabs bar_tabs">
                    {% for course_allotment in course_allotment_list %}
                        {% if forloop.counter == 1 %}
                            <li {% if selected_allotment_pk == course_allotment.staff_course_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="true"
                                   id={{ course_allotment.staff_course_instance.pk }}
                                           data-toggle="tab" name="course_tab">
                                    {{ course_allotment.display_text }}
                                </a>
                            </li>
                        {% else %}
                            <li {% if selected_allotment_pk == course_allotment.staff_course_instance.pk %}class="active" {% else %}
                                class="" {% endif %}>
                                <a aria-expanded="false"
                                   id={{ course_allotment.staff_course_instance.pk }}
                                           data-toggle="tab" name="course_tab">
                                    {{ course_allotment.display_text }}
                                </a>
                            </li>
                        {% endif %}
                    {% endfor %}
                </ul>


                <div class="col-md-offset-10">
                    <button type="button" class="btn btn-primary" id='genrate_pdf'>
                        Generate PDF
                    </button>
                </div>

                <div class="tab-content">
                    <div class="row">
                        <form method="POST" class="form-horizontal" id="week_form">
                            <div class="form-group">
                                <div class="col-sm-2">
                                    <select id="select_week">
                                        {% for week in weeks %}
                                            {% if week.start_day == current_start_date %}
                                                <option selected="selected"
                                                        value="{{ week.start_day|date:"Y-m-d" }}_{{ week.end_day|date:"Y-m-d" }}">{{ week.start_day }}
                                                    - {{ week.end_day }}</option>
                                            {% else %}
                                                <option value="{{ week.start_day|date:"Y-m-d" }}_{{ week.end_day|date:"Y-m-d" }}">{{ week.start_day }}
                                                    - {{ week.end_day }}</option>
                                            {% endif %}
                                        {% endfor %}
                                    </select>
                                </div>
                            </div>
                        </form>
                    </div>
                    <div class="table-responsive">
                        {% if final_result %}
                            <table class="table table-striped text-center table-bordered" id="id_overall_weekly_table">
                                <thead>
                                <tr>
                                    <td>S.No.</td>
                                    <td>Roll Number</td>
                                    <td align="left">Name</td>
                                    {% for entry in date_and_hour_list %}
                                        <td>{{ entry.attendance_date|date:"d-m-Y" }}
                                            <br>{{ entry.attendance_date|date:"l" }}
                                            <br>hour : {{ entry.hour }}<br><br>
                                            {% if perms.curriculum.can_reallow_attendance %}
                                                <button class='btn btn-primary btn-round'
                                                        onclick=reallow_function({{ entry.attendance_date|date:"Y" }},{{ entry.attendance_date|date:"m" }},{{ entry.attendance_date|date:"d" }},{{ entry.hour }})
                                                        {#                                                    data-toggle="modal" data-target="#reallow_prompt" name="reallow_button">#}
                                                >Reallow
                                                </button>
                                                <br/>
                                                <button class='btn btn-danger'
                                                        onclick=delete_function({{ entry.attendance_date|date:"Y" }},{{ entry.attendance_date|date:"m" }},{{ entry.attendance_date|date:"d" }},{{ entry.hour }})
                                                        {#                                                    data-toggle="modal" data-target="#reallow_prompt" name="reallow_button">#}
                                                >Delete
                                                </button>
                                            {% endif %}
                                        </td>
                                    {% endfor %}
                                    <td>Total Hours</td>
                                    <td>Present Hours</td>
                                    <td>Absent Hours</td>
                                    <td>%</td>
                                </tr>
                                </thead>
                                <tbody>

                                {% for result in final_result %}
                                    <tr>
                                        <td>{{ forloop.counter }}</td>
                                        <td>{{ result.roll_no }}</td>
                                        <td align="left">{{ result.name }}</td>
                                        {% for entry in result.attendance_list %}
                                            {% if entry.status == 'P' %}
                                                <td><i class="fa fa-check"></i></td>
                                            {% elif entry.status == 'O' %}
                                                <td>OD</td>
                                            {% elif entry.status == 'A' %}
                                                <td>AB</td>
                                            {% else %}
                                                <td>-</td>
                                            {% endif %}
                                        {% endfor %}
                                        <td>{{ result.total_hours }}</td>
                                        <td>{{ result.present_hours }}</td>
                                        <td>{{ result.absent_hours }}</td>
                                        <td>{{ result.percentage }}</td>
                                    </tr>
                                {% endfor %}
                                </tbody>

                            </table>
                        {% endif %}
                    </div>
                </div>
            </div>
        </div>
    </div>
    <div id="reallow_prompt" class="modal fade" role="dialog">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <button type="button" class="close" data-dismiss="modal">&times;</button>
                    <h4 class="modal-title">Request Confirmation</h4>
                </div>
                <div class="modal-body">
                    <h4>This will request your HOD to enable attendance marking for this hour again. Request will
                        be under his reallow attteance request menu.</h4>
                    <h4 align="center">Are you sure?</h4>
                </div>
                <div class="clearfix"></div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-lg btn-primary" data-dismiss="modal"
                            id="reallow_request">Confirm
                    </button>
                </div>
            </div>
        </div>
    </div>

    <form id="dummy_form" method="post">
        {% csrf_token %}
    </form>

    <script type="text/javascript">
        var target_link;
        $('[name="reallow_button"]').click(function () {
            target_link = $(this).attr('data-whatever');
        })
        $('#reallow_request').click(function () {
            window.location.href = target_link;
        })
    </script>

    <script type="text/javascript">

        var curent_subject;
        function getCookie(name) {
            var cookieValue = null;
            if (document.cookie && document.cookie != '') {
                var cookies = document.cookie.split(';');
                for (var i = 0; i < cookies.length; i++) {
                    var cookie = jQuery.trim(cookies[i]);
                    // Does this cookie string begin with the name we want?
                    if (cookie.substring(0, name.length + 1) == (name + '=')) {
                        cookieValue = decodeURIComponent(cookie.substring(name.length + 1));
                        break;
                    }
                }
            }
            return cookieValue;
        }
        $('document').ready(function () {
            $('[name="department_tab"]').click(function () {
                current_department = this.id;
                //alert(this.id)

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'selected_department_pk'});
                $hiddenInput.appendTo('form');

                $('#dummy_form').submit();

            });
        });
        $('document').ready(function () {
            $('[name="course_tab"]').click(function () {
                curent_subject = this.id;
                //alert(this.id)

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: {{ selected_semester_pk }},
                    name: 'semester_pk'
                });
                //alert(this.id);
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: {{ selected_department_pk }},
                    name: 'selected_department_pk'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'selected_allotment_pk'});
                $hiddenInput.appendTo('form');

                $('#dummy_form').submit();

            });
        });
        $('document').ready(function () {
            $('#genrate_pdf').click(function () {
                //alert('sid');
                var selected_range = $('#select_week').val()
                window.location = '{% url 'weekly_attendance_pdf_report' allot_staff_pk=selected_allotment_pk start_date=current_start_date end_date=current_end_date %}';
            });
        });
        $('document').ready(function () {
            $('#select_week').change(function () {
                //alert('sid');
                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: {{ selected_department_pk }},
                    name: 'selected_department_pk'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: {{ selected_semester_pk }},
                    name: 'semester_pk'
                });
                //alert(this.id);
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: '{{ selected_allotment_pk }}',
                    name: 'selected_allotment_pk'
                });
                $hiddenInput.appendTo('form');
                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.value, name: 'date_range'});
                $hiddenInput.appendTo('form');
                $('#week_form').submit();
            });
        });

        $('document').ready(function () {
            $('[name="batch_tab"]').click(function () {

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: getCookie('csrftoken'),
                    name: 'csrfmiddlewaretoken'
                });
                $hiddenInput.appendTo('form');
                //alert($('this').textContent);

                var $hiddenInput = $('<input/>', {
                    type: 'hidden',
                    value: {{ selected_department_pk }},
                    name: 'selected_department_pk'
                });
                $hiddenInput.appendTo('form');

                var $hiddenInput = $('<input/>', {type: 'hidden', value: this.id, name: 'semester_pk'});
                //alert(this.id);
                $hiddenInput.appendTo('form');

                $('#dummy_form').submit();
            });
        });

        $(document).ready(function() {
            $('#id_overall_weekly_table').DataTable( {
                dom: 'Bfrtip',
                buttons: [
                    {
                        extend: 'excelHtml5',
                        title: '{{ selected_course_name }}' + '_internals_report',
                    },
                    {
                        extend: 'csvHtml5',
                        title: '{{ selected_course_name }}' + '_internals_report',
                    },
                ]
            } );
        } );



    </script>

{% endblock %}